enhelper = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "CandyBar-2.0","AceDB-2.0" )
enhelper:RegisterDB("EnhelperDB","EnhelperDBPC");
enhelper:RegisterDefaults("profile", {
x=300,
y=-350
} )

local numwf=0;
local lastwf=0;
local lastwfdur=3;
local ssid=0;
local sstexture=" ";
local srsid=0;
local srtexture=" ";
local shockid=0;
local shocktexture=" ";
local xres, yres = 0,0;
local options = {};

function enhelper:OnEnable()
	enhelper:FindSS()
	enhelper:FindShock()
	enhelper:FrameSET()
	self:RegisterEvent("CHAT_MSG_SPELL_SELF_DAMAGE");
	self:RegisterEvent("ACTIONBAR_UPDATE_COOLDOWN");
	self:RegisterEvent("showbest");
	-- enhelper:WFcandySET();
	-- enhelper:SScandySET();
	-- enhelper:SRcandySET();
	-- enhelper:ShockcandySET();
	-- enhelper:getscreenres();
	-- enhelper:setoptions();
	-- enhelper:RegisterChatCommand("/enhelper", "/enhelper", options);
end

function enhelper:FrameSET()
	if (not enhelper.f) then
		enhelper.f = CreateFrame("MessageFrame","EnhelperFrame",UIParent)
		enhelper.f:SetFrameStrata("BACKGROUND")
		enhelper.f:SetWidth(220); 
		enhelper.f:SetHeight(15);
		enhelper.f:SetInsertMode("TOP");
--		local t = enhelper.f:CreateTexture(nil,"BACKGROUND")
--		t:SetTexture("Interface\\Glues\\CharacterCreate\\UI-CharacterCreate-Factions.blp")
--		t:SetAllPoints(enhelper.f)
--		enhelper.f.texture = t
		enhelper.f:SetPoint("TOPLEFT", "UIParent", "TOPLEFT",enhelper.db.profile.x,enhelper.db.profile.y)
		enhelper.f:SetTimeVisible(9999999999);
		enhelper.f:SetFontObject(GameFontNormal);
	end
	enhelper.f:Show();
end

function enhelper:chkshock()
	local shstart, shduration = GetSpellCooldown(shockid,BOOKTYPE_SPELL);
	if (shstart==0) then
		EnhelperFrame:AddMessage("Shock!!!",1,1,1);
	else
		local dur=shduration - ( GetTime() - shstart);
		enhelper:Shadule(dur);
		EnhelperFrame:AddMessage(" ",1,1,1);
	end
end

function enhelper:Shadule(t)
	local sh, tsh = enhelper:IsEventScheduled("showbest");
	if (sh) then
		if (tsh>t) then
			enhelper:CancelScheduledEvent("showbest");
			enhelper:ScheduleEvent("showbest",t);
		end
	else
		enhelper:ScheduleEvent("showbest",t);
	end
	
end
function enhelper:showbest()
	enhelper:chkshock();
	local ssstart, ssduration = GetSpellCooldown(ssid,BOOKTYPE_SPELL);
	if (ssstart==0) then
		EnhelperFrame:AddMessage("SS Ready!!!",1,1,1);
		-- DEFAULT_CHAT_FRAME:AddMessage("SS Ready!!!");
		local lwf=GetTime()-lastwf;
		if (lwf<lastwfdur) then
			-- ??SHOCK
			if ((lastwf+lastwfdur-1.5)>=GetTime()) then
				EnhelperFrame:AddMessage("Free",1,1,1);
				enhelper:chkshock();
				return("Free");
			else
				EnhelperFrame:AddMessage("Wait SS",1,1,1);
				-- DEFAULT_CHAT_FRAME:AddMessage("Free");
				return("Wait");
			end
		else
			EnhelperFrame:AddMessage("SS Strike!!!",1,1,1);
			-- DEFAULT_CHAT_FRAME:AddMessage("SS Strike!!!");
			return("SS");
		end
	else
		local dur=ssduration - ( GetTime() - ssstart);
		if (dur>0) then
			
			EnhelperFrame:AddMessage("Free",1,1,1);
			enhelper:Shadule(dur);
			if(dur-1.5<0) then
				EnhelperFrame:AddMessage("Wait SS",1,1,1);
			else
				enhelper:chkshock();
				enhelper:Shadule(dur-1.5);
			end
		end
--			if 
	end
end

function enhelper:FindSS()
	for i = 1, MAX_SKILLLINE_TABS do
		local name, texture, offset, numSpells = GetSpellTabInfo(i);
		if not name then
			break;
		end
		for s = offset + 1, offset + numSpells do
	    	local spell, rank = GetSpellName(s, BOOKTYPE_SPELL);
			if (spell=="Stormstrike") then
				ssid=s;
				sstexture=GetSpellTexture(s,BOOKTYPE_SPELL);
				break;
			end
		end
	end
end

function enhelper:FindSR()
	for i = 1, MAX_SKILLLINE_TABS do
		local name, texture, offset, numSpells = GetSpellTabInfo(i);
		if not name then
			break;
		end
		for s = offset + 1, offset + numSpells do
	    	local spell, rank = GetSpellName(s, BOOKTYPE_SPELL);
			if (spell=="Shamanistic Rage") then
				srid=s;
				srtexture=GetSpellTexture(s,BOOKTYPE_SPELL);
				break;
			end
		end
	end
end

function enhelper:FindShock()
	for i = 1, MAX_SKILLLINE_TABS do
		local name, texture, offset, numSpells = GetSpellTabInfo(i);
		if not name then
			break;
		end
		for s = offset + 1, offset + numSpells do
	    	local spell, rank = GetSpellName(s, BOOKTYPE_SPELL);
			if (spell=="Earth Shock") then
				shockid=s;
				shocktexture=GetSpellTexture(s,BOOKTYPE_SPELL);
				break;
			end
		end
	end
end

function enhelper:ACTIONBAR_UPDATE_COOLDOWN()
	enhelper:showbest();
end

function enhelper:CHAT_MSG_SPELL_SELF_DAMAGE()
	local tn = UnitName("target");
	if (tn) then
		enhelper:showbest();
		local mestart, meend, mewfhit = string.find(arg1, "Your Windfury Attack (.+)\.");
		if (mewfhit) then
			seconds = GetTime();
			if ((seconds-lastwf)>1) then
				local down, up, lag = GetNetStats();
				numwf=numwf+1;
				lastwfdur=(3-lag/1000);
				enhelper:ScheduleEvent(self.showbest,(lastwfdur-1.49),self);
				enhelper:ScheduleEvent(self.showbest,lastwfdur,self);
			end
			lastwf=seconds;
		end
	end
end

function enhelper:getscreenres()
	local xyres=GetCVar("gxResolution");
	xres, yres=strsplit("x",xyres);
	xres=tonumber(xres);
	yres=tonumber(yres);
	-- DEFAULT_CHAT_FRAME:AddMessage(xres.." "..yres);
end

function enhelper:setoptions()
	options = { 
	    type='group',
	    args = {
	        wfx = {
	            type = 'range',
	            name = 'WFx',
	            desc = 'Change X coord of WF timer',
	            min = (-1)*xres/2,
				max = xres/2,
				step = 1,
				get = "GetX",
	            set = "SetX",
	        },
			wfy = {
	            type = 'range',
	            name = 'WFy',
	            desc = 'Change Y coord of WF timer',
	            min = (-1)*yres/2,
				max = yres/2,
				step = 1,
				get = "GetY",
	            set = "SetY",
	        },
			wfscale = {
	            type = 'range',
	            name = 'WFscale',
	            desc = 'Change Scale of WF timer',
	            min = 0.3,
				max = 3,
				step = 0.1,
				get = "GetScale",
	            set = "SetScale",
	        },
			showss = {
	            type = 'toggle',
	            name = 'ToggleSS',
	            desc = 'Show/Hide SS',
	            get = function()
			        return enhelper.db.profile.showss
			    end,
	            set = function(v)
			        enhelper.db.profile.showss=v;
					enhelper:SScandySET();
			    end,
				map = { [false] = "Disabled", [true] = "Enabled" }
	        },
			showshock = {
	            type = 'toggle',
	            name = 'ToggleShocks',
	            desc = 'Show/Hide Shocks',
	            get = function()
			        return enhelper.db.profile.showshock
			    end,
	            set = function(v)
			        enhelper.db.profile.showshock=v;
					enhelper:ShockcandySET();
			    end,
				map = { [false] = "Disabled", [true] = "Enabled" }
	        },
			showsr = {
	            type = 'toggle',
	            name = 'ToggleSR',
	            desc = 'Show/Hide Rage',
	            get = function()
			        return enhelper.db.profile.showsr
			    end,
	            set = function(v)
			        enhelper.db.profile.showsr=v;
					enhelper:SRcandySET();
			    end,
				map = { [false] = "Disabled", [true] = "Enabled" }
	        }


	    }
	}
end

function enhelper:GetX()
    return enhelper.db.profile.x
end

function enhelper:SetX(newValue)
	enhelper.db.profile.x = newValue;
	enhelper:SetCandyBarGroupPoint("WFcandy", "CENTER", "UIParent", "CENTER",enhelper.db.profile.x,enhelper.db.profile.y);
	enhelper:StopCandyBar("WFcandyBAR");
	enhelper:SetCandyBarTimeLeft("WFcandyBAR",3);
	enhelper:StartCandyBar("WFcandyBAR");
end

function enhelper:GetY()
    return enhelper.db.profile.y
end

function enhelper:SetY(newValue)
	enhelper.db.profile.y = newValue;
	enhelper:SetCandyBarGroupPoint("WFcandy", "CENTER", "UIParent", "CENTER",enhelper.db.profile.x,enhelper.db.profile.y);
	enhelper:StopCandyBar("WFcandyBAR");
	enhelper:SetCandyBarTimeLeft("WFcandyBAR",3);
	enhelper:StartCandyBar("WFcandyBAR");
end

function enhelper:GetScale()
    return enhelper.db.profile.scale
end

function enhelper:SetScale(newValue)
	enhelper.db.profile.scale = newValue;
	enhelper:SetCandyBarScale("WFcandyBAR", enhelper.db.profile.scale);
	if (enhelper:IsCandyBarRegistered("SScandyBAR")) then
		enhelper:SetCandyBarScale("SScandyBAR", enhelper.db.profile.scale);
	end
	if (enhelper:IsCandyBarRegistered("SRcandyBAR")) then
		enhelper:SetCandyBarScale("SRcandyBAR", enhelper.db.profile.scale);
	end
	if (enhelper:IsCandyBarRegistered("ShockcandyBAR")) then
		enhelper:SetCandyBarScale("ShockcandyBAR", enhelper.db.profile.scale);
	end
	enhelper:StopCandyBar("WFcandyBAR");
	enhelper:SetCandyBarTimeLeft("WFcandyBAR",3);
	enhelper:StartCandyBar("WFcandyBAR");
end